Summary: The Linux kernel (the core of the Linux operating system)

%define builddevfs 1
%define sublevel 23
%define kversion 2.4.%{sublevel}
%define devfsdver 1.3.25
%define kslnk linux-2.4
%define extraversion 4

# disable build root strip policy
%define __spec_install_post /usr/lib/rpm/brp-compress || :


Name: kernel
Version: %{kversion}
Release: b4
%define KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
%define KernelVer %{kversion}-%{extraversion}
Copyright: GPL
Group: System Environment/Kernel
BuildArchitectures: i586
# ExclusiveArch: i586 i386
ExclusiveOS: Linux
Obsoletes: kernel-modules kernelcfg
Provides: kernel = %{kversion}
Autoreqprov: no
Prereq: fileutils
Requires: modutils >= 2.4.2, e2fsprogs >= 1.25

Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-%{kversion}.tar.bz2
Source1: ftp://ftp.atnf.csiro.au/pub/people/rgooch/linux/daemons/devfsd-v%{devfsdver}.tar.bz2

Source2: config.berry

#Source10: rammld.tar.bz2
Source11: rescan-scsi-bus.sh
Source12: installkernel

# from redhat
Patch0: linux-2.4.0-nonintconfig.patch

Patch1: berry-logo.patch
Patch2: bootsplash-3.0.7-2.4.22-pre2.diff
#Patch1: ftp://ftp.kernel.org/pub/linux/kernel/people/alan/2.4/patch-2.4.3-ac6.bz2

BuildRoot: /var/tmp/kernel-%{KVERREL}-root


###
### desc
###
%package source
Summary: The source code for the Linux kernel.
Group: Development/System
Prereq: fileutils gawk

%package headers
Summary: Header files for the Linux kernel.
Group: Development/System
Requires: fileutils gawk

##%package doc
##Summary: Various documentation bits found in the kernel source.
##Group: Documentation

%if %{builddevfs}
%package -n devfsd
Summary: Device filesystem management daemon
Group: System Environment/Kernel
Requires: kernel >= 2.3.46
%endif

%description 
The kernel package contains the Linux kernel (vmlinuz), the core of your
Red Hat Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned
to your particular hardware, if you are so inclined (and you know what
you're doing).

%description headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
kernel.

##%description doc
##This package contains documentation files form the kernel
##source. Various bits of information about the Linux kernel and the
##device drivers shipped with it are documented in these files.
##
##You'll want to install this package if you need a reference to the
##options that can be passed to Linux kernel modules at load time.

%if %{builddevfs}
%description -n devfsd
Daemon for managing the device filesystem (devfs)
%endif


###
### prep
###
%prep

%setup -q -n %{name}-%{kversion} -c -a 1
cd linux-%{kversion}
%if %{builddevfs}
mv ../devfsd* .
%endif

# from Redhat
%patch0 -p1

# for Berry Linux Logo
%patch1 -p1
%patch2 -p1

# get rid of unwanted files
find . -name "*.orig" -exec rm -fv {} \;
find . -name "*~" -exec rm -fv {} \;

sed 's/^EXTRAVERSION =.*/EXTRAVERSION = -%{extraversion}/' Makefile > Makefile.new
mv Makefile.new Makefile
cp $RPM_SOURCE_DIR/config.berry .


###
### build
###
%build

cd linux-%{kversion}

rm -rf $RPM_BUILD_ROOT

## KernelVer=%{kversion}-%{extraversion}

# init
make -s mrproper
cp config.berry .config

# make Makefile and so on... linux-2.4.0-nonintconfig.patch
make -s oldconfig_nonint

make -s dep
## make -s include/linux/version.h
make -s bzImage
make -s modules

find include/linux/modules -size 0 | while read file ; do
echo > $file
done

# make modules_install
mkdir -p $RPM_BUILD_ROOT/boot
install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-%{KernelVer}
mkdir -p $RPM_BUILD_ROOT/dev/shm
cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-%{KernelVer}
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{KernelVer}
make -s INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=%{KernelVer}

# make some extra symlinks for pcmcia cards not caught by make modules_install
ln -s ../kernel/drivers/ide/ide-cs.o $RPM_BUILD_ROOT/lib/modules/%{KernelVer}/pcmcia/ide-cs.o
ln -s ../kernel/drivers/net/3c59x.o  $RPM_BUILD_ROOT/lib/modules/%{KernelVer}/pcmcia/3c59x.o

%if %{builddevfs}
# compile devfsd
cd devfsd
perl -pi -e "s,-O2,$RPM_OPT_FLAGS -D_GNU_SOURCE,g" GNUmakefile
make -s KERNEL_DIR=..
cd ..
%endif


###
### install
###

%install

cd linux-%{kversion}
mkdir -p $RPM_BUILD_ROOT/{boot,sbin,bin}
install -m 755 $RPM_SOURCE_DIR/installkernel $RPM_BUILD_ROOT/sbin/installkernel
install -m 755 $RPM_SOURCE_DIR/rescan-scsi-bus.sh $RPM_BUILD_ROOT/bin/rescan-scsi-bus.sh

# /lib/modules/*/build -> /usr/src/linux
for i in $RPM_BUILD_ROOT/lib/modules/*; do
  rm -f $i/build
  ###ln -sf ../../../usr/src/linux-%{KernelVer} $i/build
  ln -sf /usr/src/linux-%{KernelVer} $i/build
  ## Add Up 2003/6/4
done

# setup RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/include
## ln -sf ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux-%{KVERREL}
ln -sf /usr/src/linux-%{KernelVer}/include/linux $RPM_BUILD_ROOT/usr/include/linux
ln -sf /usr/src/linux-%{KernelVer}/include/asm $RPM_BUILD_ROOT/usr/include/asm
mkdir -p $RPM_BUILD_ROOT/usr/src
ln -sf /usr/src/linux-%{KernelVer} $RPM_BUILD_ROOT/usr/src/linux-2.4
## Add Up 2003/6/4

# install /usr/src/linux/include to /usr/include
mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}
tar cf - . | tar xf - -C $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}
## ln -sf linux-%{kversion} $RPM_BUILD_ROOT/usr/src/linux
## ln -sf ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm-%{KVERREL}
mkdir -p $RPM_BUILD_ROOT/usr/include/linux-%{KernelVer}
cp -a $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}/include/linux/* $RPM_BUILD_ROOT/usr/include/linux-%{KernelVer}/
rm -rf $RPM_BUILD_ROOT/usr/include/linux-%{KernelVer}/modules
mkdir -p $RPM_BUILD_ROOT/usr/include/asm-%{KernelVer}
cp -a $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}/include/asm/* $RPM_BUILD_ROOT/usr/include/asm-%{KernelVer}/

# clean up the destination
make -s mrproper -C $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}
cp $RPM_SOURCE_DIR/config.berry $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}/.config
make -s oldconfig_nonint -C $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}
make -s symlinks -C $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}
make -s include/linux/version.h -C $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}
make -s dep -C $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}

%if %{builddevfs}
# devfs
mkdir -p $RPM_BUILD_ROOT/sbin $RPM_BUILD_ROOT%{_mandir}/man8 $RPM_BUILD_ROOT/etc
install -m 755 -s devfsd/devfsd $RPM_BUILD_ROOT/sbin/devfsd
cp -p devfsd/devfsd.8 $RPM_BUILD_ROOT%{_mandir}/man8
cp -p devfsd/devfsd.conf $RPM_BUILD_ROOT/etc/devfsd.conf
cp -p devfsd/modules.devfs $RPM_BUILD_ROOT/etc/modules.devfs

make -s clean -C $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}/devfsd
rm -f $RPM_BUILD_ROOT/usr/src/linux-%{KernelVer}/devfsd/devfsd
%endif


##make ramimages
## before this, you must need to insert floppy disk into fd drive
#cp -p /sbin/cardctl $RPM_BUILD_ROOT/sbin/
#cp -p /sbin/cardmgr $RPM_BUILD_ROOT/sbin/
#cp -p /sbin/ide_info $RPM_BUILD_ROOT/sbin/
#cp -p /sbin/probe $RPM_BUILD_ROOT/sbin/
#cp -p /sbin/scsi_info $RPM_BUILD_ROOT/sbin/
#cd $RPM_BUILD_ROOT
#mkdir -p mldinst
#tar xvIf $RPM_SOURCE_DIR/rammld.tar.bz2
#cd rammld
#make
#cp -p rammld5.gz $RPM_BUILD_ROOT/boot/
#cp -p rampcm.gz $RPM_BUILD_ROOT/boot/
#mkdir -p $RPM_BUILD_ROOT/mldinst/bootfd
#cp -p liloimg $RPM_BUILD_ROOT/mldinst/bootfd/
#cp -p lilopcm $RPM_BUILD_ROOT/mldinst/bootfd/
#cp -p setfdopt $RPM_BUILD_ROOT/mldinst/bootfd/
#cp -p looproot $RPM_BUILD_ROOT/mldinst/bootfd/


###
### clean
###

%clean
rm -rf $RPM_BUILD_ROOT


###
### scripts
###

# do this for upgrades...in case the old modules get removed we have
# loopback in the kernel so that mkinitrd will work.
%pre 

%post 
cd /boot
ln -sf vmlinuz-%{KernelVer} vmlinuz
ln -sf System.map-%{KernelVer} System.map
depmod -a -F /boot/System.map-%{KernelVer} %{KernelVer}
exit 0

# Allow clean removal of modules directory
%preun 
rm -f /lib/modules/%{KernelVer}/modules.*

%pre headers
[ -L /usr/include/linux ] && rm -f /usr/include/linux
[ -L /usr/include/asm ] && rm -f /usr/include/asm
exit 0


###
### file lists
###

%files 
%defattr(-,root,root)
## /boot/vmlinux-%{KernelVer}
/boot/vmlinuz-%{KernelVer}
/boot/System.map-%{KernelVer}
%config /sbin/installkernel
%config /bin/rescan-scsi-bus.sh
%dir /lib/modules
%dir /dev/shm
/lib/modules/%{KernelVer}

%files source
%defattr(-,root,root)
%dir /usr/src/linux-%{KernelVer}
/usr/src/linux-%{KernelVer}/COPYING
/usr/src/linux-%{KernelVer}/CREDITS
/usr/src/linux-%{KernelVer}/Documentation
/usr/src/linux-%{KernelVer}/MAINTAINERS
/usr/src/linux-%{KernelVer}/Makefile
/usr/src/linux-%{KernelVer}/README
/usr/src/linux-%{KernelVer}/REPORTING-BUGS
/usr/src/linux-%{KernelVer}/Rules.make
/usr/src/linux-%{KernelVer}/arch/i386
/usr/src/linux-%{KernelVer}/drivers
/usr/src/linux-%{KernelVer}/fs
/usr/src/linux-%{KernelVer}/init
/usr/src/linux-%{KernelVer}/ipc
/usr/src/linux-%{KernelVer}/kernel
/usr/src/linux-%{KernelVer}/lib
/usr/src/linux-%{KernelVer}/mm
/usr/src/linux-%{KernelVer}/net
/usr/src/linux-%{KernelVer}/scripts
%if %{builddevfs}
/usr/src/linux-%{KernelVer}/devfsd
%endif
## /usr/src/linux-%{KernelVer}/configs
/usr/src/linux-%{KernelVer}/include/asm-i386
/usr/src/linux-%{KernelVer}/include/asm
/usr/src/linux-%{KernelVer}/include/asm-generic
/usr/src/linux-%{KernelVer}/include/linux
/usr/src/linux-%{KernelVer}/include/math-emu
/usr/src/linux-%{KernelVer}/include/net
/usr/src/linux-%{KernelVer}/include/pcmcia
/usr/src/linux-%{KernelVer}/include/scsi
/usr/src/linux-%{KernelVer}/include/video
/usr/src/linux-2.4
/usr/include/asm
/usr/include/linux
## Add Up 2003/6/4

%if %{builddevfs}
%files -n devfsd
%defattr(-,root,root)
/sbin/devfsd
%{_mandir}/man8/devfsd.8*
%config /etc/devfsd.conf
%config /etc/modules.devfs
%endif

%files headers
%defattr(-,root,root)
/usr/include/linux-%{KernelVer}
/usr/include/asm-%{KernelVer}
## /boot/kernel.h-%{kversion}
/usr/include/asm
/usr/include/linux
## Add Up 2003/6/4

#%files doc
#%defattr(-,root,root)
#%doc linux/Documentation/*


###
### change log
###

%changelog
* Sat Nov 29 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.23
* Mon Nov 17 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.23-rc1
* Fri Oct 10 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.23-pre7
* Mon Sep 22 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.23-pre5
* Fri Aug 15 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Added EtherExpressPro/100 support (e100, Alternate Intel driver)
- Added Asix AX88190 PCMCIA support
* Sat Jul 12 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.22-pre5
- Added NVIDIA Chipset Support (AGP)
* Mon Jul 7 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.22-pre3
* Wed Jul 2 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Added bootsplash-3.0.7
* Fri Jun 27 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.22-pre2
- Changed Berry Linux Logo
* Mon Jun 16 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.21
* Wed Jun 4 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.21-rc7
- Added Link /usr/include/{asm,linux}
- Added Link /usr/src/linux-2.4
* Tue May 27 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.21-rc4
* Fri May 23 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.21-rc3
* Fri May 9 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.21-rc2
* Thu Apr 24 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to kernel 2.4.21-rc1
* Sat Apr 12 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Bug fixed of stopping with "flushing ide devices:" messages
- Added "RTC stores time in GMT" option
* Mon Dec 23 2002 Yuichiro Nakada <berry@po.yui.mine.nu>
- Create for Berry Linux
- from Linux MLD Mini (ftp://ftp.mlb.co.jp/pub/linux/mini/SRPMS)
